import dht  # Importem llibreria
import machine  # Importem llibreria

# Calcul de la Temperatura i Humitat
def temperatura(): # Funcio que retorna una tupla amb dos valors temeperatura i humitat
    d = dht.DHT22(machine.Pin(19)) # GPIO on es DHT22
    d.measure() # llegim valor
    d.temperature() # eg. 23.6 (°C)
    d.humidity()    # eg. 41.3 (% RH)
    # Els prints de baix els mostrarem al terminal de python per veure com va el calcul
    print("T =") # Missatge
    print(d.temperature()) # Missatge amb el valor de d.temperature()
    print("H =") # Missatge
    print(d.humidity()) # Missatge amb el valor de d.humidity()
    print("  ") # Linia en blanc
    temperatura = d.temperature()  # Pasem el valor d.temperature() a una variable 
    humitat = round(d.humidity(),1)  #Arredonim humitat a un decimal amb round
    return temperatura, humitat # Tupla amb 2 valors que passarem a la una altra tupla de dins de la funcio web_page()

   
# Pagina web que mostrara el servidor    
def web_page():
    temp, humi = temperatura() #Tupla rep valor de tupla
    html = """<!DOCTYPE HTML><html><head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.2/css/all.css" integrity="sha384-fnmOCqbTlWIlj8LyTjo7mOUStjsKC4pOpQbqyi7RrhN7udi9RwhKkMHpvLbHG9Sr" crossorigin="anonymous">
  <style> html { font-family: Arial; display: inline-block; margin: 0px auto; text-align: center; }
    h2 { font-size: 3.0rem; } p { font-size: 3.0rem; } .units { font-size: 1.2rem; } 
    .ds-labels{ font-size: 1.5rem; vertical-align:middle; padding-bottom: 15px; }
  </style></head><body><h2>ESP32 DHT22 WebServer</h2>
  <p><i class="fas fa-thermometer-half" style="color:#059e8a;"></i> 
    <span class="ds-labels">Temperature</span>
    <span id="temperatura">""" + str(temp) + """</span>
    <sup class="units">&deg;C</sup>
  </p>
    <p><i class="fas fa-thermometer-half" style="color:#059e8a;"></i> 
    <span class="ds-labels">Humitat</span>
    <span id="humidity">""" + str(humi) + """</span>
    <sup class="units"> % </sup>
  </p>
  </body></html>"""
    return html

# Comuniquem servidor i clients
s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s.bind(('', 80))
s.listen(5)
 
while True:
  try:
    if gc.mem_free() < 102000:
      gc.collect()
    conn, addr = s.accept()
    conn.settimeout(3.0)
    print('Got a connection from %s' % str(addr))
    request = conn.recv(1024)
    conn.settimeout(None)
    request = str(request)
    print('Content = %s' % request)
    response = web_page()
    conn.send('HTTP/1.1 200 OK\n')
    conn.send('Content-Type: text/html\n')
    conn.send('Connection: close\n\n')
    conn.sendall(response)
    conn.close()
  except OSError as e:
    conn.close()
    print('Connection closed')
